<template>
  <section class="checkout-section">
    <div class="checkout-section__top">
      <h4 class="checkout-section__title" :class="filled ? 'checkout-section__title--filled' : ''">
        <span v-show="filled" class="checkout-section__marker">
          <icon-check />
        </span>
        {{ title }}
      </h4>

      <button type="button"
              @click="toggle()"
              class="checkout-section__btn"
              :class="isOpen ? 'checkout-section__btn--open' : ''"
      >
        <template v-if="isOpen">
          Свернуть
        </template>
        <template v-else>
          Изменить
        </template>
        <icon-small-arrow />
      </button>
    </div>

    <template v-if="!isOpen">
      <div class="checkout-section__preview-wrapper">
        <div class="checkout-section__preview">

        <span v-for="item in previewItems"
              :key="item"
              v-html="item"
              class="checkout-section__preview-item">
        </span>

        </div>
      </div>

      <div class="checkout-section__book-more" v-if="type === 'book'">
        <button type="button"
                class="button button--gray checkout-section__book-btn"
                @click="onBookMoreClick"
        >
          <icon-plus />
          Забронировать еще
        </button>
      </div>
    </template>

    <div v-else class="checkout-section__body">
      <slot/>
    </div>

  </section>
</template>

<script>
  import IconSmallArrow from './icons/IconSmallArrow';
  import IconPlus from './icons/IconPlus';
  import IconCheck from './icons/IconCheck';

  export default {
    name: 'CheckoutSection',
    components: {
      IconCheck,
      IconPlus,
      IconSmallArrow
    },
    props: {
      previewItems: {
        type: Array,
        required: true
      },

      title: {
        type: String,
        required: true,
      },

      filled: {
        type: Boolean,
        default: false
      },

      type: {
        type: String,
        required: true,
      }
    },
    data: () => ({
      isOpen: true
    }),
    methods: {
      open() {
        this.isOpen = true;
      },

      close() {
        this.isOpen = false;
      },

      toggle() {
        this.isOpen = !this.isOpen;
      },

      onBookMoreClick() {
        this.open();

        this.$nextTick(() => {
          this.$emit('bookMore')
        });
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .checkout-section {
    & + & {
      margin-top: rem(70);
    }

    &__top {
      display: flex;
      justify-content: space-between;

      margin-bottom: rem(30);
    }

    &--filled {
      .checkout-section__title::before {

      }
    }

    &__title {
      @include h4;

      display: flex;
      align-items: center;

      &.checkout-section__title--filled {
        &::before {
          content: none;
          display: none;
        }
      }

      &::before {
        @include gray-btn;
        @include bold-black-link;

        counter-increment: checkoutSections;
        content: counter(checkoutSections);

        color: $dark-gray;
      }
    }

    &__marker, &__title::before {
      display: inline-flex;
      align-items: center;
      justify-content: center;

      width: rem(26);
      height: rem(26);
      margin-right: rem(18);

      border-radius: 50%;
    }

    &__marker {
      @include green-btn;
    }

    &__btn {
      @include gray-btn;

      &:active {
        @include gray-btn-active;
      }

      &:hover {
        color: $black;

        svg {
          stroke: $black;
        }
      }

      height: rem(35);
      padding: 0 rem(18) 0 rem(20);

      font-weight: 600;
      font-size: rem(12);
      line-height: rem(22);
      color: $dark-gray;

      border-radius: rem(40);
      cursor: pointer;

      svg {
        margin-left: rem(8);
        transition: all .35s;
      }

      &--open {
        svg {
          transform: rotate(180deg) translateY(rem(2));
        }
      }
    }

    &__preview-wrapper {
      overflow: hidden;
    }

    &__preview {
      display: flex;
      flex-flow: wrap;

      margin: rem(-4) rem(-10);
    }

    &__preview-item {
      @include p1;

      margin: rem(4) rem(10);

      @media (max-width: $mobile-width) {
        font-size: rem(14);
        line-height: rem(18);
      }

      b {
        font-weight: inherit;
        color: $dark-gray;
      }

      & + & {
        &::before {
          content: '/';

          position: absolute;
          left: rem(-12);

          color: rgba($black, .2);
        }
      }
    }

    &__book-more {
      padding-top: rem(28);
      margin-top: rem(28);

      border-top: rem(1) solid #DCE2EF;
    }

    &__book-btn {
      padding-left: rem(28);
      padding-right: rem(36);

      svg {
        width: rem(12);
        height: rem(12);
        margin-right: rem(10);
      }

    }
  }

</style>
